<?php
class LocationPage extends Page {

	// Name und Icon
	static $singular_name = 'Profil-Seite';
    static $plural_name = 'Profil-Seiten';
    static $description = 'Seitentyp für Profile (Restaurants, Hotels, etc.)';
    static $icon = 'mysite/images/icons/location';


	static $db = array(
		// Main
		'StartDate'				=> 'Date',
		'EndDate'				=> 'Date',

		// Information
		'MenuCard'				=> 'Varchar(255)',
		'Category'				=> 'Enum("Restaurant, Hotel, Bar & Lounge, Club, Eventlocation, Café, Feinkost")',
		'Kitchen'				=> 'Enum(", deutsch, italienisch, international, griechisch, amerikanisch, asiatisch, englisch, französisch, indisch, mediterran, orientalisch, österreichisch, regional / saisonal, schweizerisch, spanisch, türkisch, afrikanisch, australisch, andere Länder")',
		'AlternativeKitchen'	=> 'Enum(", deutsch, italienisch, international, griechisch, amerikanisch, asiatisch, englisch, französisch, indisch, mediterran, orientalisch, österreichisch, regional / saisonal, schweizerisch, spanisch, türkisch, afrikanisch, australisch, andere Länder")',

		'Ambience'				=> 'Enum(", gehoben, luxuriös, außergewöhnlich, modern, gemütlich, verspielt, sportlich, praktisch, stilvoll, extravagant")',
		'AlternativeAmbience'	=> 'Enum(", gehoben, luxuriös, außergewöhnlich, modern, gemütlich, verspielt, sportlich, praktisch, stilvoll, extravagant")',

		'Music'					=> 'Enum(", Hip-Hop, House, Electro, Tecktonic, R&b, Techno, Licemusik, Pop, 70er, 80er, 90er, Crossover, Charts, Blackmusic, Bollywood, Indie, Industrial, Jazz, Soul, Schlager, Raggae, Salsa, Rock")',
		'AwardClassification'	=> 'Enum(",1,2,3,4,5")',
		'PriceLevel'			=> 'Enum(",1,2,3,4,5")',
		'Rooms'					=> 'Varchar(255)',


		// Contact-data
		'StreetAddress'			=> 'Varchar(255)',
		'Zip'					=> 'Varchar(10)',
		'City'					=> 'Varchar(255)',
		'Phone'					=> 'Varchar(255)',
		'EMail'					=> 'Varchar(255)',
		'Website'				=> 'Varchar(255)',
		'OpeningHours'			=> 'Varchar(255)',
		'ReservationTimes'		=> 'Varchar(255)',
		'Longitude'				=> 'Varchar(255)',
		'Latitude'				=> 'Varchar(255)',

		// Features
		// - Benefits / Services
		'TopTable'				=> 'Boolean',
		'Exteriors'				=> 'Boolean',
		'Reservation'			=> 'Boolean',
		'Dogs'					=> 'Boolean',
		'Wellness'				=> 'Boolean',
		'ConciergeService'		=> 'Boolean',
		'DJ'					=> 'Boolean',
		'Aircon'				=> 'Boolean',
		'EnglishSpeaking'		=> 'Boolean',
		'Sauna'					=> 'Boolean',
		'SmokingAreaOutside'	=> 'Boolean',
		'SmokingAreaInside'		=> 'Boolean',
		'ParkingSpaces'			=> 'Boolean',
		'DisabilityFriendly'	=> 'Boolean',
		'PoolOutside'			=> 'Boolean',
		'PoolInside'			=> 'Boolean',
		'WLAN'					=> 'Boolean',
		'Fitness'				=> 'Boolean',
		'Cocktails'				=> 'Boolean',
		'FamilyFriendly'		=> 'Boolean',

		'Fish'					=> 'Boolean',
		'Meat'					=> 'Boolean',
		'Cheese'				=> 'Boolean',
		'Antipasti'				=> 'Boolean',
		'Wine'					=> 'Boolean',
		'Liquor'				=> 'Boolean',
		'Candy'					=> 'Boolean',
		'CoffeeTea'				=> 'Boolean',
		'Oil'					=> 'Boolean',
		'FruitVegetables'		=> 'Boolean',
		'Spices'				=> 'Boolean',
		'CannedFood'			=> 'Boolean',
		'Pastries'				=> 'Boolean',

		// - Extern reservation-possibilities
		'Bookatable'			=> 'Varchar(255)',
		'Opentable'				=> 'Varchar(255)',
		'Hotel_de'				=> 'Varchar(255)',

		// - Annotations
		'SidebarText' 			=> 'Text',

		// Methods of payments
		'Cash'					=> 'Boolean',
		'Visa'					=> 'Boolean',
		'MasterCard'			=> 'Boolean',
		'ElectronicCash'		=> 'Boolean',
		'DinersClub'			=> 'Boolean',
		'AmericanExpress'		=> 'Boolean'
	);

	static $has_one = array(
		// Informationen
		'ImageFolder'	=> 'Folder'
	);

	static $alternativeFields = array(
		'Kitchen',
		'Ambience'
	);

	public $german = array(
		// Main
		'StartDate'				=> 'Falls Location veröffentlicht ist, nicht vor folgendem Datum anzeigen',
		'EndDate'				=> 'Falls Location veröffentlicht ist, nicht nach folgendem Datum anzeigen',

		// Information
		'MenuCard'				=> 'Speisekarte (externer Verweis)',
		'ImageFolderID'			=> 'Speicherort der Location-Fotos',
		'Category'				=> 'Kategorie',
		'Kitchen'				=> 'Küche (nur Restaurants und Cafés)',
		'AlternativeKitchen'	=> 'Alternative Küche (nur Restaurants und Cafés)',
		'Ambience'				=> 'Ambiente (nur Bars, Clubs und Event Locations)',
		'AlternativeAmbience'	=> 'Alternatives Ambiente (nur Bars, Clubs und Event Locations)',
		'Music'					=> 'Musik (nur Clubs)',
		'AwardClassification'	=> 'Sterne (nur Hotels)',
		'PriceLevel'			=> 'Preisniveau',
		'Rooms'					=> 'Zimmeranzahl (nur Hotels)',

		// Contact-data
		'StreetAddress'			=> 'Straße und Hausnummer',
		'Zip'					=> 'Postleitzahl',
		'City'					=> 'Ort',
		'Phone'					=> 'Telefon',
		'EMail'					=> 'E-Mail',
		'Website'				=> 'Internetpräsenz (beginnend mit http://)',
		'OpeningHours'			=> 'Öffnungszeiten',
		'ReservationTimes'		=> 'Reservierungszeiten (nur Hotels)',
		'Latitude'				=> 'Breitengrad',
		'Longitude'				=> 'Längengrad',

		// Features
		// - Benefits / Services
		'TopTable'				=> 'Top Table',
		'Exteriors'				=> 'Außenbereich vorhanden',
		'Reservation'			=> 'Reservierung dringend empfohlen',
		'Dogs'					=> 'Hunde erlaubt',
		'Wellness'				=> 'Wellness-Bereich',
		'ConciergeService'		=> 'Concierge Service',
		'DJ'					=> 'DJ',
		'Aircon'				=> 'Klimaanlage im Zimmer',
		'EnglishSpeaking'		=> 'Das Personal spricht englisch',
		'Sauna'					=> 'Sauna',
		'SmokingAreaOutside'	=> 'Raucherbereich vorhanden',
		'SmokingAreaInside'		=> 'Raucherzimmer',
		'ParkingSpaces'			=> 'Parkplätze vorhanden',
		'DisabilityFriendly'	=> 'Barrierefrei',
		'PoolOutside'			=> 'Pool außen',
		'PoolInside'			=> 'Pool innen',
		'WLAN'					=> 'W-LAN',
		'Fitness'				=> 'Fitness',
		'Cocktails'				=> 'Cocktails',
		'FamilyFriendly'		=> 'Familienfreundlich',

		'Fish'					=> 'Fisch',
		'Meat'					=> 'Fleisch',
		'Cheese'				=> 'Käse',
		'Antipasti'				=> 'Antipasti',
		'Wine'					=> 'Wein',
		'Liquor'				=> 'Spirituosen',
		'Candy'					=> 'Süßwaren',
		'CoffeeTea'				=> 'Kaffee und Tee',
		'Oil'					=> 'Öle',
		'FruitVegetables'		=> 'Obst und Gemüse',
		'Spices'				=> 'Gewürze',
		'CannedFood'			=> 'Konserven',
		'Pastries'				=> 'Backwaren',

		// - Extern reservation-possibilities
		'Bookatable'			=> 'Bookatable',
		'Opentable'				=> 'Opentable',
		'Hotel_de'				=> 'Hotel.de',

		// - Annotations
		'SidebarText' 			=> 'Zusätzlicher Text',

		// Methods of payments
		'Cash'					=> 'Barzahlung',
		'Visa'					=> 'Visa',
		'MasterCard'			=> 'MasterCard',
		'ElectronicCash'		=> 'EC-Karte',
		'DinersClub'			=> 'Diners',
		'AmericanExpress'		=> 'American Express'
	);

	public function getCMSFields() {
		$this->labels = $this->german;

		$fields = parent::getCMSFields();

		// Main
		$fields->addFieldToTab('Root.Content.Main', $StartDate = new DateField('StartDate', $this->labels['StartDate']), 'Content');
		$StartDate->setConfig('showcalendar', true);
		$fields->addFieldToTab('Root.Content.Main', $EndDate = new DateField('EndDate', $this->labels['EndDate']), 'Content');
		$EndDate->setConfig('showcalendar', true);

		// Information
		$fields->addFieldToTab('Root.Content.Informationen', new TreeDropdownField('ImageFolderID', $this->labels['ImageFolderID'], 'Folder'));
		$fields->addFieldToTab('Root.Content.Informationen', new TextField('MenuCard', $this->labels['MenuCard']));
		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('Category', $this->labels['Category'], $this->dbObject('Category')->enumValues()));

		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('Kitchen', $this->labels['Kitchen'], $this->dbObject('Kitchen')->enumValues()));
		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('AlternativeKitchen', $this->labels['AlternativeKitchen'], $this->dbObject('AlternativeKitchen')->enumValues()));

		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('Ambience', $this->labels['Ambience'], $this->dbObject('Ambience')->enumValues()));
		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('AlternativeAmbience', $this->labels['AlternativeAmbience'], $this->dbObject('AlternativeAmbience')->enumValues()));

		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('Music', $this->labels['Music'], $this->dbObject('Music')->enumValues()));

		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('AwardClassification', $this->labels['AwardClassification'], $this->dbObject('AwardClassification')->enumValues()));
		$fields->addFieldToTab('Root.Content.Informationen', new DropdownField('PriceLevel', $this->labels['PriceLevel'], $this->dbObject('PriceLevel')->enumValues()));
		$fields->addFieldToTab('Root.Content.Informationen', new TextField('Rooms', $this->labels['Rooms']));

		// Contact-data
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('StreetAddress', $this->labels['StreetAddress']));
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('Zip', $this->labels['Zip']));
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('City', $this->labels['City']));
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('Phone', $this->labels['Phone']));
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('EMail', $this->labels['EMail']));
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('Website', $this->labels['Website']));
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextareaField('OpeningHours', $this->labels['OpeningHours'], 2));
		$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('ReservationTimes', $this->labels['ReservationTimes']));
		//$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('Latitude', $this->labels['Latitude']));
		//$fields->addFieldToTab('Root.Content.Kontaktdaten', new TextField('Longitude', $this->labels['Longitude']));


		// Features
		// - Benefits / services
		$fields->addFieldtoTab('Root.Content.Besonderheiten', new HeaderField ('Leistungen/Service','3'));
		$fields->addFieldtoTab('Root.Content.Besonderheiten', new HeaderField ('Allgemein: alle Kategorien','4'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Dogs', $this->labels['Dogs']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('ParkingSpaces', $this->labels['ParkingSpaces']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('EnglishSpeaking', $this->labels['EnglishSpeaking']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Exteriors', $this->labels['Exteriors']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('WLAN', $this->labels['WLAN']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('DisabilityFriendly', $this->labels['DisabilityFriendly']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('SmokingAreaOutside', $this->labels['SmokingAreaOutside']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('FamilyFriendly', $this->labels['FamilyFriendly']));

		$fields->addFieldtoTab('Root.Content.Besonderheiten', new HeaderField ('Restaurant: nur für Restaurants gültig','4'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Reservation', $this->labels['Reservation']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('TopTable', $this->labels['TopTable']));

		$fields->addFieldtoTab('Root.Content.Besonderheiten', new HeaderField ('Hotel: nur für Hotels gültig','4'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('PoolOutside', $this->labels['PoolOutside']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('PoolInside', $this->labels['PoolInside']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Sauna', $this->labels['Sauna']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Wellness', $this->labels['Wellness']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Fitness', $this->labels['Fitness']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('ConciergeService', $this->labels['ConciergeService']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('SmokingAreaInside', $this->labels['SmokingAreaInside']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Aircon', $this->labels['Aircon']));

		$fields->addFieldtoTab('Root.Content.Besonderheiten', new HeaderField ('Club/Bar u. Lounge: nur für Clubs und Bar u. Lounges gültig','4'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('DJ', $this->labels['DJ']));

		$fields->addFieldtoTab('Root.Content.Besonderheiten', new HeaderField ('Restaurant/Club/Bar u. Lounge: nur für Restaurants, Clubs und Bar u. Lounges gültig','4'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Cocktails', $this->labels['Cocktails']));

		$fields->addFieldtoTab('Root.Content.Besonderheiten', new HeaderField ('Feinkost: nur für Feinkost gültig','4'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Fish', $this->labels['Fish']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Meat', $this->labels['Meat']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Cheese', $this->labels['Cheese']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Antipasti', $this->labels['Antipasti']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Wine', $this->labels['Wine']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Liquor', $this->labels['Liquor']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Candy', $this->labels['Candy']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('CoffeeTea', $this->labels['CoffeeTea']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Oil', $this->labels['Oil']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('FruitVegetables', $this->labels['FruitVegetables']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Spices', $this->labels['Spices']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('CannedFood', $this->labels['CannedFood']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new CheckboxField('Pastries', $this->labels['Pastries']));

		// - Extern reservation-possibilities
		$fields->addFieldtoTab('Root.Content.Besonderheiten', new LiteralField('headline', '<h3><br />Buchungsmöglichkeiten</h3>'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new TextField('Bookatable', $this->labels['Bookatable']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new TextField('Opentable', $this->labels['Opentable']));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new TextField('Hotel_de', $this->labels['Hotel_de']));

		// - Annotations
		$fields->addFieldtoTab('Root.Content.Besonderheiten', new LiteralField('headline', '<h3><br />Anmerkungen</h3>'));
		$fields->addFieldToTab('Root.Content.Besonderheiten', new TextareaField('SidebarText', $this->labels['SidebarText'], 5));

		// Methods of payments
		$fields->addFieldToTab('Root.Content.Zahlungsarten', new CheckboxField('Cash', $this->labels['Cash']));
		$fields->addFieldToTab('Root.Content.Zahlungsarten', new CheckboxField('Visa', $this->labels['Visa']));
		$fields->addFieldToTab('Root.Content.Zahlungsarten', new CheckboxField('MasterCard', $this->labels['MasterCard']));
		$fields->addFieldToTab('Root.Content.Zahlungsarten', new CheckboxField('ElectronicCash', $this->labels['ElectronicCash']));
		$fields->addFieldToTab('Root.Content.Zahlungsarten', new CheckboxField('DinersClub', $this->labels['DinersClub']));
		$fields->addFieldToTab('Root.Content.Zahlungsarten', new CheckboxField('AmericanExpress', $this->labels['AmericanExpress']));

		// Need to be removed, else they would be duplicates
		$fields->removeFieldFromTab('Root.Content.Main', 'ImageFolder');
		$fields->removeFieldFromTab('Root.Content.Main', 'MenuCard');

		// Currently not needed, maybe later
		$fields->removeFieldFromTab('Root.Content.Main', 'StartDate');
		$fields->removeFieldFromTab('Root.Content.Main', 'EndDate');

		return $fields;
	}

	// Transform URL into a cleaner and more readable way (www.example.com)
	function niceURL() {
		$niceURL = parse_url($this->Website);

		return $niceURL['host'];
	}

	function onBeforeWrite() {
		parent::onBeforeWrite();

		$street 		= urlencode($this->record['StreetAddress']);
		$zip 			= urlencode($this->record['Zip']);
		$city 			= urlencode($this->record['City']);
		$googleMapsURL 	= "http://maps.google.com/maps/geo?q=$street,+$zip+$city,+Germany&output=json";
		$jsonFile = file_get_contents($googleMapsURL);

		if (empty($jsonFile)) {
			//Datei existiert nicht / ist leer oder konnte nicht vom Server geladen werden
			DB::query("UPDATE $this SET Latitude=0, Longitude=0 WHERE id=$this->ID");
		} else {
			$decodedJsonFile = json_decode($jsonFile);
			$lat = $decodedJsonFile->Placemark[0]->Point->coordinates[1];
			$lng = $decodedJsonFile->Placemark[0]->Point->coordinates[0];
			DB::query("UPDATE $this SET Latitude=$lat, Longitude=$lng WHERE id=$this->ID");
		}
	}
}

class LocationPage_Controller extends Page_Controller {
	// Get the value of an attribute (multilingual)
	public function getAttribute($attribute) { return _t('attributes.' . $attribute); }

	// Starting with "The" will return the language-specific value
	public function TheCategory() { return $this->getAttribute($this->Category); }
	public function TheAmbience() { return $this->getAttribute($this->Ambience); }
	public function TheAlternativeAmbience() { return $this->getAttribute($this->AlternativeAmbience); }
	public function TheKitchen() { return $this->getAttribute($this->Kitchen); }
	public function TheAlternativeKitchen() { return $this->getAttribute($this->AlternativeKitchen); }
	public function TheMusic() { return $this->getAttribute($this->Music); }

	// Define special meta-title
	public function MetaTitle() {
		return sprintf(_t("locationPage.MetaTitle"), $this->TheCategory(), $this->MenuTitle, $this->Parent->MenuTitle);
	}

	// Define special meta--tags
	public function MetaTags($includeTitle = true) {
		$tags = '';

		// Set title if it need to be included
		if($includeTitle === true || $includeTitle == 'true') {
			$tags .= "<title>" . $this->MetaTitle() . "</title>\n";
		}

		// Charset
		$tags .= '<meta http-equiv="Content-type" content="text/html; charset=' . ContentNegotiator::get_encoding() . '" />' . "\n";

		// Keywords
		if($this->MetaKeywords) {
			$tags .= '<meta name="keywords" content="' . Convert::raw2att($this->MetaKeywords) . '" />' . "\n";
		}

		// Description
		$tags .= "<meta name=\"description\" content=\"" . sprintf(_t("locationPage.MetaDescription"), $this->TheCategory(), $this->Parent->MenuTitle, $this->MenuTitle, $this->StreetAddress, $this->Zip, $this->City) . "\" />\n";

		// Extra-meta
		if($this->ExtraMeta) {
			$tags .= $this->ExtraMeta . "\n";
		}

		$this->extend('MetaTags', $tags);

		return $tags;
	}

	// Create the full address for the static google map
	public function GoogleMapAddress() {
		return urlencode($this->StreetAddress) . ',' . urlencode($this->Zip) . '+' . urlencode($this->City);
	}

	// Create a random image
	public function RandomImage($id = FALSE) {
		if ( $id == FALSE ) $id = $this->ImageFolderID;
		return DataObject::get("File", $filter = "ParentID = {$id}", $sort = "RAND()")->First();
	}

	// Create the slideshow
	public function Slideshow() {
		$results = DataObject::get("File", $filter = "ParentID = {$this->ImageFolderID}");
		foreach ( $results as $row ) {
			if ( $row->Width > 810 ) {
				$row = $row->setWidth(810);
			}

			$items[] = $row;
		}

		return new DataObjectSet($items);
	}
}
